MODULE Math0;

IMPORT Math;

VAR
  pi*     :REAL;
  tpi*    :REAL;
  degrees :REAL;
  radians :REAL;  
  PiOver2 :REAL;

PROCEDURE ArcSin*(x : REAL): REAL;
VAR
  rv : REAL;
BEGIN
  IF x = -1.0 THEN
    rv := -PiOver2
	ELSIF x = 1.0 THEN
    rv := PiOver2
	ELSIF (x < -1.0) OR (x > 1.0) THEN
    ASSERT(FALSE, 7) (* Division by zero or.. *)
  ELSE
    rv := Math.ArcTan(x / Math.Sqrt(1.0 - x*x));
	END;
	RETURN rv
END ArcSin;

PROCEDURE ArcCos*(x : REAL) : REAL;
BEGIN
  RETURN PiOver2 - ArcSin(x)
END ArcCos;
  
PROCEDURE DegSin*(v : REAL): REAL;
BEGIN
  RETURN Math.Sin(radians * v)
END DegSin;

PROCEDURE DegCos*(v : REAL): REAL;
BEGIN
  RETURN Math.Cos(radians * v)
END DegCos;

PROCEDURE Tan*(x : REAL): REAL;
BEGIN
  RETURN Math.Sin(x) / Math.Cos(x)
END Tan;

PROCEDURE DegTan*(v : REAL): REAL;
BEGIN
  RETURN Tan(radians * v)
END DegTan;

PROCEDURE DegArcTan*(v : REAL): REAL;
BEGIN
  RETURN degrees * Math.ArcTan(v)
END DegArcTan;

PROCEDURE DegArcSin*(v : REAL): REAL;
BEGIN
  RETURN degrees * ArcSin(v)
END DegArcSin;

PROCEDURE DegArcCos*(v : REAL): REAL;
BEGIN
  RETURN degrees * ArcCos(v)
END DegArcCos;

PROCEDURE InitVar;
BEGIN
  pi := 3.14159265358979323846;
  tpi := 2.0 * pi;
  degrees := 180.0 / pi;
  radians := pi / 180.0;
  PiOver2 := pi / 2.0;
END InitVar;

BEGIN
  InitVar
END Math0.
