MODULE SunRiseTest;
(* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
   :::  Here is test harness. This code should be removed for production.      :::
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: *)
IMPORT Out, SunRiseSet, Convert, Strings, Main;

(* Convert number to a time, HH:MM format  *)
PROCEDURE hhmm(h: REAL; VAR out : ARRAY OF CHAR);
VAR
  frac: REAL;
  hr, mn: INTEGER;
  works: ARRAY 4 OF CHAR;
BEGIN
  hr := FLOOR(h); frac := h - FLT(hr);
  mn := FLOOR(60.0 * frac + 0.5);
  Convert.IntToStr(hr, works); 
  IF hr < 10 THEN Strings.Insert("0", 0, works) END;
  Strings.Copy(works, out); 
  Strings.Append(":", out); 
  Convert.IntToStr(mn, works); 
  IF mn < 10 THEN Strings.Insert("0", 0, works) END;
  Strings.Append(works, out);
END hhmm;

(* display outcome of SunRise/SunSet calculation *)
PROCEDURE display(v : REAL; SunRise : BOOLEAN);
VAR
  note : ARRAY 80 OF CHAR;
  time : ARRAY 12 OF CHAR;
BEGIN
  IF v >= 0.0 THEN
    IF SunRise THEN
      Out.String("Sunrise at ")
    ELSE
      Out.String("Sunset at  ")
    END;
    hhmm(v, time);
    Out.String(time)
  ELSIF v = -1.0 THEN
    Out.String("The sun never rises on this location on the specified date)") 
  ELSIF v = -2.0 THEN
    Out.String("The sun never sets on this location on the specified date)") 
  ELSE
    Out.String("How did we get here ?")
  END;
  Out.Ln
END display;
(* 
  Example data taken from williams.best.vwh.net.sunrise_sunset_example.htm
   
  time := GetTime(40.9, -74.3, -4.0, TRUE,  1990, 6, 25);
  This should calculate a sunrise at 5:26 am EDT
  
  parms are:
    1- latitude,                        REAL
    2- longitude,                       REAL
    3- timezone (1.0=+60min),           REAL
    4- TRUE=SunRise OR FALSE=SunSet,    BOOLEAN
    5- Year,                            INTEGER
    6- Month,                           INTEGER
    7- Day OF month                     INTEGER
*)
    
PROCEDURE go;
VAR
  sunrise, sunset : REAL;
  riseflag : BOOLEAN;
BEGIN 
  (* testcase from website *)
  riseflag := TRUE;
  sunrise := SunRiseSet.GetTime(40.9, -74.3, -4.0, riseflag,  1990, 6, 25);
  display(sunrise, riseflag);
  riseflag := FALSE;
  sunset  := SunRiseSet.GetTime(40.9, -74.3, -4.0, riseflag,  1990, 6, 25);
  display(sunset, riseflag);
  (* now for my case: Ams, NL, recently *)
  riseflag := TRUE;  
  sunrise := SunRiseSet.GetTime(52.22, 4.53, +2.0, riseflag,  2011, 8, 13);
  display(sunrise, riseflag);
  riseflag := FALSE;
  sunset  := SunRiseSet.GetTime(52.22, 4.53, +2.0, riseflag,  2011, 8, 13);
  display(sunset, riseflag)
END go;

BEGIN
  go
END SunRiseTest.

